diff --git a/base/deploy/src/scriptlets/pkijython.py b/base/deploy/src/scriptlets/pkijython.py
index ffd8884..0c482bb 100644
--- a/base/deploy/src/scriptlets/pkijython.py
+++ b/base/deploy/src/scriptlets/pkijython.py
@@ -154,23 +154,6 @@ import pkimessages as log
 
 
 # PKI Deployment Jython Helper Functions
-def extract_sensitive_data(configuration_file):
-    "Read 'sensitive' configuration file section into a dictionary"
-    try:
-        parser = ConfigParser.ConfigParser()
-        # Make keys case-sensitive!
-        parser.optionxform = str
-        parser.read(configuration_file)
-        # return dict(parser._sections['Sensitive'])
-        dictionary = {}
-        for option in parser.options('Sensitive'):
-            dictionary[option] = parser.get('Sensitive', option)
-        return dictionary
-    except ConfigParser.ParsingError, err:
-        javasystem.out.println(log.PKI_JYTHON_EXCEPTION_PARSER + " '" +\
-                               configuration_file + "':  " + str(err))
-        javasystem.exit(1)
-
 def generateCRMFRequest(token, keysize, subjectdn, dualkey):
         kg = token.getKeyPairGenerator(KeyPairAlgorithm.RSA)
         x = Integer(keysize)
@@ -285,7 +268,7 @@ class rest_client:
             e.printStackTrace()
             javasystem.exit(1)
 
-    def construct_pki_configuration_data(self, master, token):
+    def construct_pki_configuration_data(self, master, sensitive, token):
         data = None
         if master['pki_jython_log_level'] >= config.PKI_JYTHON_INFO_LOG_LEVEL:
             print "%s %s '%s'" %\
@@ -293,10 +276,9 @@ class rest_client:
                    log.PKI_JYTHON_CONSTRUCTING_PKI_DATA,
                    master['pki_subsystem'])
         if not master['pki_dry_run_flag']:
-            sensitive = extract_sensitive_data(master['pki_deployment_cfg'])
             data = ConfigurationData()
             # Miscellaneous Configuration Information
-            data.setPin(master['pki_one_time_pin'])
+            data.setPin(sensitive['pki_one_time_pin'])
             data.setToken(ConfigurationData.TOKEN_DEFAULT)
             if master['pki_instance_type'] == "Tomcat":
                 data.setSubsystemName(master['pki_subsystem_name'])
@@ -390,7 +372,7 @@ class rest_client:
             if master['pki_instance_type'] == "Tomcat":
                 if config.str2bool(master['pki_backup_keys']):
                     data.setBackupKeys("true")
-                    data.setBackupFile(master['pki_backup_file'])
+                    data.setBackupFile(master['pki_backup_keys_p12'])
                     data.setBackupPassword(
                         sensitive['pki_backup_password'])
                 else:
@@ -569,7 +551,7 @@ class rest_client:
             data.setSystemCerts(systemCerts)
         return data
 
-    def configure_pki_data(self, data, master):
+    def configure_pki_data(self, data, master, sensitive):
         if master['pki_jython_log_level'] >= config.PKI_JYTHON_INFO_LOG_LEVEL:
             print "%s %s '%s'" %\
                   (log.PKI_JYTHON_INDENTATION_2,
@@ -577,7 +559,6 @@ class rest_client:
                    master['pki_subsystem'])
         if not master['pki_dry_run_flag']:
             try:
-                sensitive = extract_sensitive_data(master['pki_deployment_cfg'])
                 response = self.client.configure(data)
                 javasystem.out.println(log.PKI_JYTHON_RESPONSE_STATUS +\
                                        " " + response.getStatus())
@@ -595,7 +576,7 @@ class rest_client:
                     javasystem.out.println(log.PKI_JYTHON_CDATA_REQUEST + " " +\
                                            cdata.getRequest())
                 # Store the Administration Certificate in a file
-                admin_cert_file = os.path.join(master['pki_client_path'],
+                admin_cert_file = os.path.join(master['pki_client_dir'],
                                                master['pki_client_admin_cert'])
                 javasystem.out.println(log.PKI_JYTHON_ADMIN_CERT_SAVE +\
                                        " " + "'" + admin_cert_file + "'")
@@ -626,7 +607,7 @@ class rest_client:
                           "-f" + " " +\
                           master['pki_client_password_conf'] + " " +\
                           "-d" + " " +\
-                          master['pki_client_database_path'] + " " +\
+                          master['pki_client_database_dir'] + " " +\
                           "-a" + " " +\
                           "-i" + " " +\
                           admin_cert_file
@@ -643,7 +624,7 @@ class rest_client:
                           re.sub("&#39;", "'", master['pki_admin_nickname']) +\
                           "\"" + " " +\
                           "-d" + " " +\
-                          master['pki_client_database_path'] + " " +\
+                          master['pki_client_database_dir'] + " " +\
                           "-k" + " " +\
                           master['pki_client_password_conf'] + " " +\
                           "-w" + " " +\
diff --git a/base/deploy/src/scriptlets/pkimanifest.py b/base/deploy/src/scriptlets/pkimanifest.py
index 4f45e4b..04a638f 100644
--- a/base/deploy/src/scriptlets/pkimanifest.py
+++ b/base/deploy/src/scriptlets/pkimanifest.py
@@ -65,8 +65,6 @@ class record(object):
 
 # PKI Deployment Manifest File Class
 class file:
-    """FUTURE:  Consider creating a single manifest file
-       that is always overwritten."""
     global database
     filename = None
 
diff --git a/base/deploy/src/scriptlets/pkimessages.py b/base/deploy/src/scriptlets/pkimessages.py
index 9dfd454..ccd7570 100644
--- a/base/deploy/src/scriptlets/pkimessages.py
+++ b/base/deploy/src/scriptlets/pkimessages.py
@@ -55,17 +55,6 @@ PKI_VERBOSITY=\
 
 # PKI Deployment Error Messages
 PKI_BADZIPFILE_ERROR_1 = "zipfile.BadZipFile:  %s!"
-PKI_CUSTOM_APACHE_INSTANCE_1 = "When a custom '%s' subsystem is being "\
-                               "deployed, the 'instance', 'http_port', and "\
-                               "'https_port' must ALL be specified!"
-PKI_CUSTOM_TOMCAT_INSTANCE_1 = "When a custom '%s' subsystem is being "\
-                               "deployed, the 'instance', 'http_port', "\
-                               "'https_port', and 'ajp_port' must ALL be "\
-                               "specified!"
-PKI_CUSTOM_TOMCAT_AJP_PORT_1 = "When a custom '%s' subsystem is being "\
-                               "deployed, ONLY the 'instance', "\
-                               "'http_port', and 'https_port' MUST be "\
-                               "specified; NO 'ajp_port' should be requested!"
 PKI_DIRECTORY_ALREADY_EXISTS_1 = "Directory '%s' already exists!"
 PKI_DIRECTORY_ALREADY_EXISTS_NOT_A_DIRECTORY_1 = "Directory '%s' already "\
                                                  "exists BUT it is NOT a "\
@@ -81,6 +70,7 @@ PKI_FILE_ALREADY_EXISTS_NOT_A_FILE_1 = "File '%s' already "\
 PKI_FILE_MISSING_OR_NOT_A_FILE_1 = "File '%s' is either missing "\
                                    "or is NOT a regular file!"
 PKI_FILE_NOT_A_WAR_FILE_1 = "File '%s' is NOT a war file!"
+PKI_INSTANCE_DOES_NOT_EXIST_1 = "PKI instance '%s' does NOT exist!"
 PKI_SECURITY_DATABASES_ALREADY_EXIST_3 = "Security databases '%s', '%s', "\
                                          "and/or '%s' already exist!"
 PKI_SECURITY_DATABASES_DO_NOT_EXIST_3 = "Security databases '%s', '%s', "\
@@ -113,6 +103,17 @@ PKIDESTROY_BEGIN_MESSAGE_2 = "BEGIN destroying subsystem '%s' of "\
                              "instance '%s' . . ."
 PKIDESTROY_END_MESSAGE_2 = "END destroying subsystem '%s' of "\
                            "instance '%s'"
+PKIDESTROY_EPILOG =\
+"REMINDER:\n\n"\
+"    The default PKI instance path will be calculated and placed in front\n"\
+"    of the mandatory '-i <instance>' parameter, and the values that reside\n"\
+"    in a copy of the 'pkideployment.cfg' file that was most recently used\n"\
+"    by this instance's 'pkispawn' (or 'pkispawn -u') command will be\n"\
+"    utilized by 'pkidestroy' to remove this instance.\n\n"\
+"    Finally, if an optional '-p <prefix>' is defined, this value WILL be\n"\
+"    prepended to the default PKI instance path which is placed in front\n"\
+"    of the specified '-i <instance>' parameter.\n\n" +\
+PKI_VERBOSITY
 PKIRESPAWN_BEGIN_MESSAGE_2 = "BEGIN respawning subsystem '%s' of "\
                              "instance '%s' . . ."
 PKIRESPAWN_END_MESSAGE_2 = "END respawning subsystem '%s' of "\
@@ -121,6 +122,20 @@ PKISPAWN_BEGIN_MESSAGE_2 = "BEGIN spawning subsystem '%s' of "\
                            "instance '%s' . . ."
 PKISPAWN_END_MESSAGE_2 = "END spawning subsystem '%s' of "\
                          "instance '%s'"
+PKISPAWN_EPILOG =\
+"REMINDER:\n\n"\
+"    If two or more Apache or Tomcat PKI 'instances' are specified via\n"\
+"    separate configuration files, remember that the following parameters\n"\
+"    MUST differ between PKI 'instances':\n\n"\
+"        Apache:  'pki_instance_name', 'pki_http_port', and 'pki_https_port'\n"\
+"        Tomcat:  'pki_instance_name', 'pki_http_port', 'pki_https_port',\n"\
+"                 'pki_ajp_port', and 'pki_tomcat_server_port'\n\n"\
+"    Optionally, the 'pki_admin_domain_name' may be changed instead of, or\n"\
+"    in addition to, the 'pki_instance_name' since a PKI instance is\n"\
+"    defined as '${pki_instance_name}[.${pki_admin_domain_name}]'.\n\n"\
+"    Finally, if an optional '-p <prefix>' is defined, this value WILL NOT\n"\
+"    be prepended in front of the mandatory '-f <configuration_file>'.\n\n" +\
+PKI_VERBOSITY
 
 
 # PKI Deployment "Helper" Messages
@@ -147,6 +162,9 @@ PKIHELPER_CERTUTIL_SELF_SIGNED_CERTIFICATE_1 = "executing '%s'"
 PKIHELPER_CHMOD_2 = "chmod %o %s"
 PKIHELPER_CHOWN_3 = "chown %s:%s %s"
 PKIHELPER_CHOWN_H_3 = "chown -h %s:%s %s"
+PKIHELPER_COMMAND_LINE_PARAMETER_MISMATCH_2 = "the command-line parameter "\
+                                              "'%s' DOES NOT match the "\
+                                              "configuration file value '%s'!"
 PKIHELPER_COPY_WITH_SLOT_SUBSTITUTION_2 = "copying '%s' --> '%s' "\
                                           "with slot substitution"
 PKIHELPER_CP_P_2 = "cp -p %s %s"
@@ -166,7 +184,7 @@ PKIHELPER_GROUP_ADD_KEYERROR_1 = "KeyError:  pki_group %s"
 PKIHELPER_INVALID_SELINUX_CONTEXT_FOR_PORT = "port %s has invalid selinux "\
                                              "context %s"
 PKIHELPER_INVOKE_JYTHON_3 = "executing 'export %s;"\
-                            "jython %s %s <master_dictionary>'"
+                            "jython %s %s <master_dictionary> <sensitive_data>'"
 PKIHELPER_IS_A_DIRECTORY_1 = "'%s' is a directory"
 PKIHELPER_IS_A_FILE_1 = "'%s' is a file"
 PKIHELPER_IS_A_SYMLINK_1 = "'%s' is a symlink"
@@ -209,18 +227,11 @@ PKIHELPER_TOMCAT_INSTANCES_2 = "instance '%s' contains '%d' "\
                                "Tomcat PKI subsystems"
 PKIHELPER_TOUCH_1 = "touch %s"
 PKIHELPER_UID_2 = "UID of '%s' is %s"
-PKIHELPER_UNDEFINED_ADMIN_PASSWORD_1 =\
-    "A value for 'pki_admin_password' MUST be defined in '%s'"
-PKIHELPER_UNDEFINED_BACKUP_PASSWORD_1 =\
-    "A value for 'pki_backup_password' MUST be defined in '%s'"
-PKIHELPER_UNDEFINED_CLIENT_PKCS12_PASSWORD_1 =\
-    "A value for 'pki_client_pkcs12_password' MUST be defined in '%s'"
-PKIHELPER_UNDEFINED_CLONE_PKCS12_PASSWORD_1 =\
-    "A value for 'pki_clone_pkcs12_password' MUST be defined in '%s'"
-PKIHELPER_UNDEFINED_DS_PASSWORD_1 =\
-    "A value for 'pki_ds_password' MUST be defined in '%s'"
-PKIHELPER_UNDEFINED_SECURITY_DOMAIN_PASSWORD_1 =\
-    "A value for 'pki_security_domain_password' MUST be defined in '%s'"
+PKIHELPER_UNDEFINED_CLIENT_DATABASE_PASSWORD_2 =\
+    "Either a value for '%s' MUST be defined in '%s', or "\
+    "the randomly generated client pin MUST be used"
+PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 =\
+    "A value for '%s' MUST be defined in '%s'"
 PKIHELPER_USER_1 = "retrieving UID for '%s' . . ."
 PKIHELPER_USER_ADD_2 = "adding UID '%s' for user '%s' . . ."
 PKIHELPER_USER_ADD_DEFAULT_2 = "adding default UID '%s' for user '%s' . . ."
